<?xml version="1.0"?>

<st-source>
<!-- Changes in change set 2010-12-02_PVAdaptor-Base Extensions-diffs -->
<time-stamp>From VisualWorks®, 7.3.1 of April 20, 2005 on December 2, 2010 at 3:27:40 pm</time-stamp>


<class>
<name>PvSystemSupport</name>
<environment>PROVISO</environment>
<super>External.ExternalInterface</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports>
			PROVISO.PvSystemSupportDictionary.*
			</imports>
<category>PV-Support</category>
<attributes>
<includeFiles></includeFiles>
<includeDirectories></includeDirectories>
<libraryFiles></libraryFiles>
<libraryDirectories><item>/usr/lib/oracle/10.1.0.3/client/lib</item> <item>/home/carry/Green.293</item> <item>[unix]/usr/lib</item> <item>[win]$(windir)\system32</item> <item>/home/cmeshare/masters/baseGreen/linux86</item></libraryDirectories>
<beVirtual>false</beVirtual>
<optimizationLevel>debug</optimizationLevel>
<package>PV-Base Extensions</package>
</attributes>
</class>

<class>
<name>PvUnixSystemSupport</name>
<environment>PROVISO</environment>
<super>PROVISO.PvSystemSupport</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports>
			PROVISO.PvUnixSystemSupportDictionary.*
			</imports>
<category>PV-Support</category>
<attributes>
<includeFiles><item>sys/types.h</item> <item>sys/statvfs.h</item> <item>unistd.h</item> <item>sys/stat.h</item> <item>netdb.h</item> <item>sys/systeminfo.h</item></includeFiles>
<includeDirectories><item>/usr/include</item></includeDirectories>
<libraryFiles><item>libprovisodc.so</item> <item>libc.so</item> <item>libnsl.so</item></libraryFiles>
<libraryDirectories><item>/usr/lib/oracle/10.1.0.3/client/lib</item> <item>/home/carry/Green.293</item> <item>[unix]/usr/lib</item> <item>[win]$(windir)\system32</item> <item>/home/cmeshare/masters/baseGreen/linux86</item></libraryDirectories>
<beVirtual>false</beVirtual>
<optimizationLevel>debug</optimizationLevel>
<package>PV-Base Extensions</package>
</attributes>
</class>

<class>
<name>PvLinuxSystemSupport</name>
<environment>PROVISO</environment>
<super>PROVISO.PvUnixSystemSupport</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports>
			PROVISO.PvLinuxSystemSupportDictionary.*
			</imports>
<category>PV-Support</category>
<attributes>
<includeFiles><item>sys/types.h</item> <item>sys/statvfs.h</item> <item>unistd.h</item> <item>sys/stat.h</item></includeFiles>
<includeDirectories><item>/usr/include</item></includeDirectories>
<libraryFiles><item>libprovisodc.so</item> <item>libc.so</item> <item>libnsl.so</item></libraryFiles>
<libraryDirectories><item>/usr/lib/oracle/10.1.0.3/client/lib</item> <item>/home/carry/Green.293</item> <item>[unix]/usr/lib</item> <item>[win]$(windir)\system32</item> <item>/home/cmeshare/masters/baseGreen/linux86</item></libraryDirectories>
<beVirtual>false</beVirtual>
<optimizationLevel>debug</optimizationLevel>
<package>PV-Base Extensions</package>
</attributes>
</class>

<methods>
<class-id>Net.URLwithPath</class-id> <category>accessing</category>

<body package="PVAdaptor-Base Extensions" selector="ubaEncodingType">ubaEncodingType
	"&lt;Symbol&gt; Answer the encoding type of the receiver."

	| tmp |
	tmp := self tail.
	(tmp asUppercase endsWith: '.ZIP') 
		ifTrue: [^#alcatelZip].
	(tmp endsWith: '.Z') 
		ifTrue: [^#compress].
	(tmp asUppercase endsWith: '.GZ')
		ifTrue: [^#gz].
	^#raw</body>
</methods>


<methods>
<class-id>Net.FileURL</class-id> <category>PROVISO</category>

<body package="PVAdaptor-Base Extensions" selector="ubaMoveDecodedInto:">ubaMoveDecodedInto: destURI 
	"Move the receiver to the destURI, decoding the receiver if necessary.  Eventually need to reify these encoding types and maintain a registry of encoding types."
	
	| type |
	type := self ubaEncodingType.
	type == #compress 
		ifTrue: 
			[| tmpURI |
			tmpURI := 
				self directory construct: 
					(self tail 
						copyFrom: 1
						to: self tail size - 2).
			[ExternalProcess defaultClass 
				execute: 'uncompress'
				args: (Array with: self asFilename asString)] 
					on: Error
					do: 
						[:ex | 
						ExternalProcess defaultClass 
							execute: 'gunzip'
							args: (Array with: self asFilename asString)].
			destURI copyFromURI: tmpURI.
			(tmpURI respondsTo: #delete) 
				ifTrue: [tmpURI delete].
			^self].
	type == #gz 
		ifTrue: 
			[| tmpURI |
			tmpURI := 
				self directory construct: 
					((self tail reverse readStream
						upTo: $.;
						upToEnd) reverse, '.tmp').
			PROVISO.PvGzipStream 
				oldFileNamed: self asFilename
				do: 
					[:in | 
					tmpURI asFilename writeStreamDo: 
						[:out | 
						out binary.
						[in atEnd] 
							whileFalse: [out nextPutAll: (in nextAvailable: 256)]]].
			tmpURI asFilename renameTo: destURI asFilename.
			^self].
	type == #raw 
		ifTrue: 
			[self asFilename renameTo: destURI asFilename.
			^self].
	^super ubaMoveDecodedInto: destURI</body>
</methods>


<methods>
<class-id>PROVISO.PvGzipStream class</class-id> <category>instance creation</category>

<body package="PV-Base Extensions" selector="oldFileNamed:do:">oldFileNamed: aString do: aBlock 
	
	| stream |
	stream := self oldFileNamed: aString.
	[aBlock value: stream] 
		ensure: [stream close]</body>
</methods>



</st-source>
